<?php

/**
 * Field handler to present an add to cart form for the kit..
 */

class commerce_kit_handler_field_add_kit_to_cart_form extends views_handler_field {
  function construct() {
    parent::construct();

    $this->additional_fields['product_id'] = 'product_id';
  }

  function option_definition() {
    $options = parent::option_definition();

    $options['show_quantity'] = array('default' => FALSE);
    $options['default_quantity'] = array('default' => 1);
    $options['display_path'] = array('default' => FALSE);

    return $options;
  }

  /**
   * Provide the add to cart display options.
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['show_quantity'] = array(
      '#type' => 'checkbox',
      '#title' => t('Display a textfield quantity widget on the add to cart form.'),
      '#default_value' => $this->options['show_quantity'],
    );

    $form['default_quantity'] = array(
      '#type' => 'textfield',
      '#title' => t('Default quantity'),
      '#default_value' => $this->options['default_quantity'] <= 0 ? 1 : $this->options['default_quantity'],
      '#element_validate' => array('commerce_cart_field_formatter_settings_form_quantity_validate'),
      '#size' => 16,
    );

    $form['display_path'] = array(
      '#type' => 'checkbox',
      '#title' => t("Link products added to the cart from this View to this View's path if displayed as a page."),
      '#default_value' => $this->options['display_path'],
    );
  }

  function query() {
    $this->ensure_my_table();
    $this->add_additional_fields();
  }

  function render($values) {
    
    //dpm($values);
   
    // TODO: Figure out how to get all product elements and then render
    // it as a kit (As I've done 3 times now)
    $product_id = $this->get_value($values, 'product_id');
    
    $product = commerce_product_load($product_id);
    //dpm($product);
    
    $product_type = commerce_product_type_load($product->type);
    //dpm($product_type);
    
    //////////////////////////////////////////////////////////////////////
    // Retrieve the commerce_product_references attached to this product
    //////////////////////////////////////////////////////////////////////
    
    // TODO: Fix this hack
    // I think I should be using field_attach_load for this but I'll
    // be fucked if I can format the $entities parameter in the way it wants...
    $field_info = field_info_field_by_ids();
    $valid_fields = array();
    foreach ($field_info as $field) {
      if ($field['type'] != 'commerce_product_reference')
        continue;

      foreach($field['bundles'] as $bundle) {
        if (in_array($product->type, $bundle)){
          $valid_fields[] = $field;
        }
        //$dpm($bundle);
      } 
    }
    // This is how it should work but I never get the field list back?
    /*$entities = array(); 
    $entities['id'] = $product_id;
    $entities['bundle'] = $product->type;
    field_attach_load('commerce_product', array($product_id => $product));
    */
    //foreach ($extra_fields as $name => $settings) {
    //  dpm($name);
    //}
    
    
    // Now we know all the fields related to this product
    //print_r($valid_fields);

    // TODO: Find the values of the related fields for this product
    // $valid_fields['field_name'] matches the value in $product

    $form_fields = array();
    
    $form_fields['kit_items']['parent'] = $product_id;
    
    foreach($valid_fields as $field) {
        $this_field = $product->$field['field_name'];
        $form_fields['kit_items'][$field['field_name']] = $product->$field['field_name'];
    }
    
    return commerce_kit_create_form($form_fields);
  }
}
